diff -r -Nup gnome-panel-2.28.0-1.fc12.src/gnome-panel.spec gnome-panel-2.28.0-1.fc12.1.src/gnome-panel.spec
--- gnome-panel-2.28.0-1.fc12.src/gnome-panel.spec	2009-09-24 04:36:40.000000000 +0400
+++ gnome-panel-2.28.0-1.fc12.1.src/gnome-panel.spec	2009-09-30 18:38:51.000000000 +0400
@@ -22,7 +22,7 @@
 Summary: GNOME panel
 Name: gnome-panel
 Version: 2.28.0
-Release: 1%{?dist}
+Release: 1%{?dist}.1
 URL: http://www.gnome.org
 Source0: http://download.gnome.org/sources/gnome-panel/2.28/%{name}-%{version}.tar.bz2
 
@@ -354,6 +354,9 @@ fi
 %{_datadir}/gtk-doc/html/*
 
 %changelog
+* Wed Sep 30 2009 Arkady L. Shane <ashejn@yandex-team.ru> 2.28.0-1
+- added keyboard applet to panel
+
 * Wed Sep 23 2009 Matthias Clasen <mclasen@redhat.com> 2.28.0-1
 - Update to 2.28.0
 
diff -r -Nup gnome-panel-2.28.0-1.fc12.src/redhat-panel-default-setup.entries gnome-panel-2.28.0-1.fc12.1.src/redhat-panel-default-setup.entries
--- gnome-panel-2.28.0-1.fc12.src/redhat-panel-default-setup.entries	2009-06-02 08:41:12.000000000 +0400
+++ gnome-panel-2.28.0-1.fc12.1.src/redhat-panel-default-setup.entries	2009-09-15 14:57:58.000000000 +0400
@@ -70,6 +70,9 @@
           <value>
             <string>fast_user_switch_applet</string>
           </value>
+          <value>
+            <string>keyboard_applet</string>
+          </value>
         </list>
       </value>
     </entry>
@@ -388,6 +391,60 @@
     <entry><key>applets/gnote/launcher_location</key><schema_key>/schemas/apps/panel/objects/launcher_location</schema_key></entry>
     <entry><key>applets/gnote/action_type</key><schema_key>/schemas/apps/panel/objects/action_type</schema_key></entry>
 
+    <!-- Keyboard Applet -->
+          
+    <entry>
+      <key>applets/keyboard_applet/object_type</key>
+      <schema_key>/schemas/apps/panel/objects/object_type</schema_key>
+      <value>
+        <string>bonobo-applet</string>
+      </value>
+    </entry>
+    <entry>
+      <key>applets/keyboard_applet/toplevel_id</key>
+      <schema_key>/schemas/apps/panel/objects/toplevel_id</schema_key>
+      <value>
+        <string>top_panel</string>
+      </value>
+    </entry>
+    <entry>
+      <key>applets/keyboard_applet/position</key>
+      <schema_key>/schemas/apps/panel/objects/position</schema_key>
+      <value>
+        <int>2</int>
+      </value>
+    </entry>
+    <entry>
+      <key>applets/keyboard_applet/panel_right_stick</key>
+      <schema_key>/schemas/apps/panel/objects/panel_right_stick</schema_key>
+      <value>
+        <bool>true</bool>
+      </value>
+    </entry>
+    <entry>
+      <key>applets/keyboard_applet/locked</key>
+      <schema_key>/schemas/apps/panel/objects/locked</schema_key>
+      <value>
+        <bool>true</bool>
+      </value>
+    </entry>
+    <entry>
+      <key>applets/keyboard_applet/bonobo_iid</key>
+      <schema_key>/schemas/apps/panel/objects/bonobo_iid</schema_key>
+      <value>
+        <string>OAFIID:GNOME_KeyboardApplet</string>
+      </value>
+    </entry>
+
+    <entry><key>applets/keyboard_applet/attached_toplevel_id</key><schema_key>/schemas/apps/panel/objects/attached_toplevel_id</schema_key></entry>
+    <entry><key>applets/keyboard_applet/tooltip</key><schema_key>/schemas/apps/panel/objects/tooltip</schema_key></entry>
+    <entry><key>applets/keyboard_applet/use_custom_icon</key><schema_key>/schemas/apps/panel/objects/use_custom_icon</schema_key></entry>
+    <entry><key>applets/keyboard_applet/custom_icon</key><schema_key>/schemas/apps/panel/objects/custom_icon</schema_key></entry>
+    <entry><key>applets/keyboard_applet/use_menu_path</key><schema_key>/schemas/apps/panel/objects/use_menu_path</schema_key></entry>
+    <entry><key>applets/keyboard_applet/menu_path</key><schema_key>/schemas/apps/panel/objects/menu_path</schema_key></entry>
+    <entry><key>applets/keyboard_applet/launcher_location</key><schema_key>/schemas/apps/panel/objects/launcher_location</schema_key></entry>
+    <entry><key>applets/keyboard_applet/action_type</key><schema_key>/schemas/apps/panel/objects/action_type</schema_key></entry>
+
   <!-- Fast User Switch Applet -->
 
     <entry>