diff -r -Nup xkeyboard-config-1.6-3.fc12.src/xkeyboard-config-1.5-rctrl-rshift.patch xkeyboard-config-1.6-3.fc12.1.src/xkeyboard-config-1.5-rctrl-rshift.patch
--- xkeyboard-config-1.6-3.fc12.src/xkeyboard-config-1.5-rctrl-rshift.patch	1970-01-01 03:00:00.000000000 +0300
+++ xkeyboard-config-1.6-3.fc12.1.src/xkeyboard-config-1.5-rctrl-rshift.patch	2009-03-23 17:14:48.000000000 +0300
@@ -0,0 +1,77 @@
+diff -urN xkeyboard-config-1.5.orig/rules/base.o_s.part xkeyboard-config-1.5/rules/base.o_s.part
+--- xkeyboard-config-1.5.orig/rules/base.o_s.part	2009-03-23 17:11:27.000000000 +0300
++++ xkeyboard-config-1.5/rules/base.o_s.part	2009-03-23 17:11:58.000000000 +0300
+@@ -19,6 +19,7 @@
+   grp:alts_toggle	=	+group(alts_toggle)
+   grp:ctrl_shift_toggle	=	+group(ctrl_shift_toggle)
+   grp:lctrl_lshift_toggle	=	+group(lctrl_lshift_toggle)
++  grp:rctrl_rshift_toggle	=	+group(rctrl_rshift_toggle)
+   grp:caps_toggle	=	+capslock(grouplock)
+   grp:caps_switch       =       +capslock(groupshift)
+   grp:shift_caps_toggle	=	+group(shift_caps_toggle)
+diff -urN xkeyboard-config-1.5.orig/rules/base.xml.in xkeyboard-config-1.5/rules/base.xml.in
+--- xkeyboard-config-1.5.orig/rules/base.xml.in	2009-03-23 17:11:27.000000000 +0300
++++ xkeyboard-config-1.5/rules/base.xml.in	2009-03-23 17:12:30.000000000 +0300
+@@ -4229,6 +4229,12 @@
+       </option>
+       <option>
+         <configItem>
++          <name>grp:rctrl_rshift_toggle</name>
++          <_description>Right Ctrl+Right Shift</_description>
++        </configItem>
++      </option>      
++      <option>
++        <configItem>
+           <name>grp:ctrl_alt_toggle</name>
+           <_description>Alt+Ctrl</_description>
+         </configItem>
+diff -urN xkeyboard-config-1.5.orig/rules/evdev.xml.in xkeyboard-config-1.5/rules/evdev.xml.in
+--- xkeyboard-config-1.5.orig/rules/evdev.xml.in	2009-03-23 17:11:27.000000000 +0300
++++ xkeyboard-config-1.5/rules/evdev.xml.in	2009-03-23 17:13:03.000000000 +0300
+@@ -4229,6 +4229,12 @@
+       </option>
+       <option>
+         <configItem>
++          <name>grp:rctrl_rshift_toggle</name>
++          <_description>Right Ctrl+Right Shift</_description>
++        </configItem>
++      </option>
++      <option>
++        <configItem>
+           <name>grp:ctrl_alt_toggle</name>
+           <_description>Alt+Ctrl</_description>
+         </configItem>
+diff -urN xkeyboard-config-1.5.orig/symbols/group xkeyboard-config-1.5/symbols/group
+--- xkeyboard-config-1.5.orig/symbols/group	2009-03-23 17:11:27.000000000 +0300
++++ xkeyboard-config-1.5/symbols/group	2009-03-23 17:14:07.000000000 +0300
+@@ -120,6 +120,19 @@
+     key <LCTL>	{	[	Control_L,	ISO_Next_Group ]	};
+ };
+ 
++// using the group(rctrl_rshift_toggle) map, pressing:
++//     Control_R+Shift_R locks the next group
++// If you have two groups and group wrap is enabled, the effect is
++// indistinguishable.
++partial modifier_keys
++xkb_symbols "rctrl_rshift_toggle" {
++    key <RTSH> {
++    type[Group1]="PC_CONTROL_LEVEL2",
++    symbols[Group1]= [ Shift_R, ISO_Next_Group ]
++    };
++    key <RCTL>  {   [   Control_R,  ISO_Next_Group ]    };
++};
++
+ // using the group(shift_caps_toggle) map, pressing:
+ //     Shift+Caps Lock toggles group
+ partial modifier_keys
+diff -urN xkeyboard-config-1.5.orig/symbols/symbols.dir xkeyboard-config-1.5/symbols/symbols.dir
+--- xkeyboard-config-1.5.orig/symbols/symbols.dir	2009-03-23 17:11:27.000000000 +0300
++++ xkeyboard-config-1.5/symbols/symbols.dir	2009-03-23 17:14:18.000000000 +0300
+@@ -745,6 +745,7 @@
+ --p----- -m------ group(shifts_toggle)
+ --p----- -m------ group(ctrl_shift_toggle)
+ --p----- -m------ group(lctrl_lshift_toggle)
++--p----- -m------ group(rctrl_rshift_toggle)
+ --p----- -m------ group(shift_caps_toggle)
+ --p----- -m------ group(shift_caps_switch)
+ --p----- -m------ group(win_menu_switch)
diff -r -Nup xkeyboard-config-1.6-3.fc12.src/xkeyboard-config.spec xkeyboard-config-1.6-3.fc12.1.src/xkeyboard-config.spec
--- xkeyboard-config-1.6-3.fc12.src/xkeyboard-config.spec	2009-08-18 03:19:12.000000000 +0400
+++ xkeyboard-config-1.6-3.fc12.1.src/xkeyboard-config.spec	2009-09-15 16:15:57.000000000 +0400
@@ -4,7 +4,7 @@
 Summary: X Keyboard Extension configuration data
 Name: xkeyboard-config
 Version: 1.6
-Release: 3%{?dist}
+Release: 3%{?dist}.1
 License: MIT
 Group: User Interface/X
 URL: http://www.freedesktop.org/wiki/Software/XKeyboardConfig
@@ -15,6 +15,7 @@ Source0: http://xlibs.freedesktop.org/xk
 # Both upstream
 Patch1: xkeyboard-config-1.6-caps-super.patch
 Patch2: xkeyboard-config-1.6-caps-hyper.patch
+Patch3:	xkeyboard-config-1.5-rctrl-rshift.patch
 
 BuildArch: noarch
 
@@ -48,15 +49,19 @@ interface. 
 %prep
 %setup -q -n %{name}-%{version}
 
-git init-db
-if [ -z "$GIT_COMMITTER_NAME" ]; then
-    git config user.email "x@fedoraproject.org"
-    git config user.name "Fedora X Ninjas"
-fi
-git add .
-git commit -a -q -m "%{version} baseline."
-
-git am -p1 $(awk '/^Patch.*:/ { print "%{_sourcedir}/"$2 }' %{_specdir}/%{name}.spec)
+#git init-db
+#if [ -z "$GIT_COMMITTER_NAME" ]; then
+#    git config user.email "x@fedoraproject.org"
+#    git config user.name "Fedora X Ninjas"
+#fi
+#git add .
+#git commit -a -q -m "%{version} baseline."
+#
+#git am -p1 $(awk '/^Patch.*:/ { print "%{_sourcedir}/"$2 }' %{_specdir}/%{name}.spec)
+
+%patch1 -p1
+%patch2 -p1
+%patch3 -p1
 
 %build
 %configure \